com.amazonaws.services.cloudfront.model

## Class AllowedMethods

- java.lang.Object
- - com.amazonaws.services.cloudfront.model.AllowedMethods

All Implemented Interfaces:
  Serializable, Cloneable

    public class AllowedMethods
    extends Object
    implements Serializable, Cloneable

A complex type that controls which HTTP methods CloudFront processes and forwards to your Amazon S3 bucket or your custom origin. There are three choices:

- CloudFront forwards only `GET` and `HEAD` requests.

- CloudFront forwards only `GET`, `HEAD`, and `OPTIONS` requests.

- CloudFront forwards `GET, HEAD, OPTIONS, PUT, PATCH, POST`, and `DELETE` requests.

If you pick the third choice, you may need to restrict access to your Amazon S3 bucket or to your custom origin so users can't perform operations that you don't want them to. For example, you might not want users to have permissions to delete objects from your origin.

See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`AllowedMethods()`

### Method Summary

All Methods Instance Methods Concrete Methods
`AllowedMethods` `clone()`
`boolean` `equals(Object obj)`
`CachedMethods` `getCachedMethods()`
`List<String>` `getItems()` A complex type that contains the HTTP methods that you want CloudFront to process and forward to your origin.
`Integer` `getQuantity()` The number of HTTP methods that you want CloudFront to forward to your origin.
`int` `hashCode()`
`void` `setCachedMethods(CachedMethods cachedMethods)`
`void` `setItems(Collection<String> items)` A complex type that contains the HTTP methods that you want CloudFront to process and forward to your origin.
`void` `setQuantity(Integer quantity)` The number of HTTP methods that you want CloudFront to forward to your origin.
`String` `toString()` Returns a string representation of this object; useful for testing and debugging.
`AllowedMethods` `withCachedMethods(CachedMethods cachedMethods)`
`AllowedMethods` `withItems(Collection<String> items)` A complex type that contains the HTTP methods that you want CloudFront to process and forward to your origin.
`AllowedMethods` `withItems(Method... items)` A complex type that contains the HTTP methods that you want CloudFront to process and forward to your origin.
`AllowedMethods` `withItems(String... items)` A complex type that contains the HTTP methods that you want CloudFront to process and forward to your origin.
`AllowedMethods` `withQuantity(Integer quantity)` The number of HTTP methods that you want CloudFront to forward to your origin.

### Methods inherited from class java.lang.Object

`finalize, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### AllowedMethods

    public AllowedMethods()

### Method Detail

#### setQuantity

    public void setQuantity(Integer quantity)

The number of HTTP methods that you want CloudFront to forward to your origin. Valid values are 2 (for `GET` and `HEAD` requests), 3 (for `GET`, `HEAD`, and `OPTIONS` requests) and 7 (for `GET, HEAD, OPTIONS, PUT, PATCH, POST`, and `DELETE` requests).

Parameters:
  `quantity` - The number of HTTP methods that you want CloudFront to forward to your origin. Valid values are 2 (for `GET` and `HEAD` requests), 3 (for `GET`, `HEAD`, and `OPTIONS` requests) and 7 (for `GET, HEAD, OPTIONS, PUT, PATCH, POST`, and `DELETE` requests).

#### getQuantity

    public Integer getQuantity()

The number of HTTP methods that you want CloudFront to forward to your origin. Valid values are 2 (for `GET` and `HEAD` requests), 3 (for `GET`, `HEAD`, and `OPTIONS` requests) and 7 (for `GET, HEAD, OPTIONS, PUT, PATCH, POST`, and `DELETE` requests).

Returns:
  The number of HTTP methods that you want CloudFront to forward to your origin. Valid values are 2 (for `GET` and `HEAD` requests), 3 (for `GET`, `HEAD`, and `OPTIONS` requests) and 7 (for `GET, HEAD, OPTIONS, PUT, PATCH, POST`, and `DELETE` requests).

#### withQuantity

    public AllowedMethods withQuantity(Integer quantity)

The number of HTTP methods that you want CloudFront to forward to your origin. Valid values are 2 (for `GET` and `HEAD` requests), 3 (for `GET`, `HEAD`, and `OPTIONS` requests) and 7 (for `GET, HEAD, OPTIONS, PUT, PATCH, POST`, and `DELETE` requests).

Parameters:
  `quantity` - The number of HTTP methods that you want CloudFront to forward to your origin. Valid values are 2 (for `GET` and `HEAD` requests), 3 (for `GET`, `HEAD`, and `OPTIONS` requests) and 7 (for `GET, HEAD, OPTIONS, PUT, PATCH, POST`, and `DELETE` requests).
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### getItems

    public List<String> getItems()

A complex type that contains the HTTP methods that you want CloudFront to process and forward to your origin.

Returns:
  A complex type that contains the HTTP methods that you want CloudFront to process and forward to your origin.
See Also:
  `Method`

#### setItems

    public void setItems(Collection<String> items)

A complex type that contains the HTTP methods that you want CloudFront to process and forward to your origin.

Parameters:
  `items` - A complex type that contains the HTTP methods that you want CloudFront to process and forward to your origin.
See Also:
  `Method`

#### withItems

    public AllowedMethods withItems(String... items)

A complex type that contains the HTTP methods that you want CloudFront to process and forward to your origin.

NOTE: This method appends the values to the existing list (if any). Use `setItems(java.util.Collection)` or `withItems(java.util.Collection)` if you want to override the existing values.

Parameters:
  `items` - A complex type that contains the HTTP methods that you want CloudFront to process and forward to your origin.
Returns:
  Returns a reference to this object so that method calls can be chained together.
See Also:
  `Method`

#### withItems

    public AllowedMethods withItems(Collection<String> items)

A complex type that contains the HTTP methods that you want CloudFront to process and forward to your origin.

Parameters:
  `items` - A complex type that contains the HTTP methods that you want CloudFront to process and forward to your origin.
Returns:
  Returns a reference to this object so that method calls can be chained together.
See Also:
  `Method`

#### withItems

    public AllowedMethods withItems(Method... items)

A complex type that contains the HTTP methods that you want CloudFront to process and forward to your origin.

Parameters:
  `items` - A complex type that contains the HTTP methods that you want CloudFront to process and forward to your origin.
Returns:
  Returns a reference to this object so that method calls can be chained together.
See Also:
  `Method`

#### setCachedMethods

    public void setCachedMethods(CachedMethods cachedMethods)

Parameters:
  `cachedMethods` -

#### getCachedMethods

    public CachedMethods getCachedMethods()

Returns:

#### withCachedMethods

    public AllowedMethods withCachedMethods(CachedMethods cachedMethods)

Parameters:
  `cachedMethods` -
Returns:
  Returns a reference to this object so that method calls can be chained together.

#### toString

    public String toString()

Returns a string representation of this object; useful for testing and debugging.

Overrides:
  `toString` in class `Object`
Returns:
  A string representation of this object.
See Also:
  `Object.toString()`

#### equals

    public boolean equals(Object obj)

Overrides:
  `equals` in class `Object`

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `Object`

#### clone

    public AllowedMethods clone()

Overrides:
  `clone` in class `Object`